__author__ = 'Martin'

from array_types import array_

class TriangularArray(array_):
        def __init__(self, rows, numbered=False, fill=None):
            super(TriangularArray, self).__init__(int((1+rows) / 2 * rows), numbered=numbered, fill=fill)

        def _compute_index(self, indices):  # indices is a tuple
            row = indices[0]
            column = indices[1]
            if column > row:
                row, column = column, row   # swap row with column
            row_total =  (row-1)* row // 2
            return row_total + column

        def __getitem__(self, indices):
            if indices[0] == indices[1]:
                return 0
            ix = self._compute_index(indices)
            return list.__getitem__(self, ix)


t_array = TriangularArray(9)
                # 0 PORTSMOUTH
t_array.assign([572, # 1 ABERDEEN
                225, 461, # 2 ABERYSTWITH
                438, 177, 312, # 3 AYR
                161, 594, 222, 452, # 4 BARNSTAPLE
                393, 182, 323, 136, 355, # 5 BERWICK
                143, 420, 119, 288, 184, 266, # 6 BIRMINGHAM
                269, 222, 164, 196, 299, 189, 125, # 7 BLACKPOOL
                 50, 565, 214, 441, 120, 434, 150, 277, # 8 BOURMOUTH
                 47, 566, 266, 458, 215, 406, 184, 291, 93]) # 9 BRIGHTON

print(t_array[1, 1])    # ABERDEEN - ABERDEEN
print(t_array[0, 1])    # PORTSMOUTH - ABERDEEN
print(t_array[3, 4])    # AYR - BARNSTAPLE
print(t_array[9, 8])    # BRIGHTON - BOURMOUTH
print(t_array[2, 7])    # ABERYSTWITH - BLACKPOOL

